﻿//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Generator.Test.TestReference
{


    /// <summary>
    /// A class that exposes the IConfiguredService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute( typeof( IFeatureProvider ) )]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute( System.ComponentModel.Composition.CreationPolicy.Shared )]
    public partial class ConfiguredServiceProvider : IFeatureProvider
    {

        private IConfiguredService _implementation;

        private Tecan.Sila2.Server.ISiLAServer _server;

        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly( typeof( ConfiguredServiceProvider ).Assembly, "ConfiguredService.sila.xml" );

        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public ConfiguredServiceProvider( IConfiguredService implementation, Tecan.Sila2.Server.ISiLAServer server )
        {
            _implementation = implementation;
            _server = server;
        }

        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }

        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register( IServerBuilder registration )
        {
            registration.RegisterUnobservableCommand<AccelerateToRequestDto, EmptyRequest>( "AccelerateTo", AccelerateTo );
            registration.RegisterUnobservableProperty( "Speed", GetSpeed );
        }

        /// <summary>
        /// Executes the Accelerate To command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest AccelerateTo( AccelerateToRequestDto request )
        {
            try
            {
                request.Validate();
                _implementation.AccelerateTo( new Tecan.Sila2.Generator.Test.TestReference.Speed( request.Target.TryExtract( _server, "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                                "/Parameter/Target" ) ), request.MaxAcceleration.TryExtract( _server, "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                            "/Parameter/MaxAcceleration" ), System.TimeSpan.FromSeconds( request.TimeRange.TryExtract( _server, "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                                "/Parameter/TimeRange" ) ) );
                return EmptyRequest.Instance;
            }
            catch(System.ArgumentException ex)
            {
                if((ex.ParamName == "target"))
                {
                    throw _server.ErrorHandling.CreateValidationError( "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                            "/Parameter/Target", ex.Message );
                }
                if((ex.ParamName == "maxAcceleration"))
                {
                    throw _server.ErrorHandling.CreateValidationError( "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                            "/Parameter/MaxAcceleration", ex.Message );
                }
                if((ex.ParamName == "timeRange"))
                {
                    throw _server.ErrorHandling.CreateValidationError( "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                            "/Parameter/TimeRange", ex.Message );
                }
                throw _server.ErrorHandling.CreateUnknownValidationError( ex );
            }
        }

        /// <summary>
        /// Gets the current value of the Speed property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual SpeedResponseDto GetSpeed()
        {
            return new SpeedResponseDto( _implementation.GetSpeed().Kmph, _server );
        }

        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand( string commandIdentifier )
        {
            if((commandIdentifier == "tecan.sila.generator.test/testreference/ConfiguredService/v4/Command/AccelerateTo" +
                ""))
            {
                return typeof( IConfiguredService ).GetMethod( "AccelerateTo" );
            }
            return null;
        }

        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty( string propertyIdentifier )
        {
            if((propertyIdentifier == "tecan.sila.generator.test/testreference/ConfiguredService/v4/Property/Speed"))
            {
                return typeof( IConfiguredService ).GetProperty( "Speed" );
            }
            return null;
        }
    }
}

